/*
 * Copyright (c) 2015 Vasa Consulting LLC
 *
 * This file is part of TYPE61CHK.
 *
 * TYPE61CHK is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * TYPE61CHK is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with TYPE61CHK.  If not, see <http://www.gnu.org/licenses/>.
 */

/*
 * Function prototypes for GPGME, libcURL, libLDNS, and OpenSSL/SHA helpers
 */

/* libCURL helpers */
_Bool	init_curl(char *from);
void	free_curl(void);
void	add_recp_to_curl(char *recp);
int		add_msg_to_curl(char *msg, char *sender);

/* GPGME helpers */
_Bool	init_gpgme(void);
void	free_gpgme(void);
char   *encrypt_with_gpgme(char *sender, char *msg, char *openpgpkey);

/* OpenSSL/SHA helpers */
void	init_sha(void);
int		hash_user(char *user, char *user_hashed);

/* libLDNS helpers */
void	free_ldns(void);
char   *query_text_ldns(void);
_Bool	send_email_via_curl(void);
int		fetch_openpgpkey(char *user_hashed, char *domain, char **openpgpkey);
