/*
 * Copyright (c) 2015 Vasa Consulting LLC
 *
 * This file is part of TYPE61CHK.
 *
 * TYPE61CHK is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * TYPE61CHK is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with TYPE61CHK.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stdio.h>
#include <string.h>
#include <sysexits.h>
#include <openssl/sha.h>
#include "support.h"

static SHA256_CTX	ctx;

void
init_sha()
{
	SHA224_Init(&ctx);
}

int
hash_user(char *user, char *user_hashed)
{
	unsigned int	len;
	unsigned char	md[SHA224_DIGEST_LENGTH];

	len =  strlen(user);

	SHA224_Update(&ctx, user, len);
	SHA224_Final(md, &ctx);

    int i;
    for (i = 0; i < SHA224_DIGEST_LENGTH; i++) {
		sprintf(user_hashed + (i * 2), "%02x", md[i]);
    }

	return EX_OK;
}

